var Point_Widget = function(position,dad){
	this.dad = dad
	this.widgetType = 0
	this.position = position
	this.object = new THREE.Mesh(new THREE.CubeGeometry(16,16,16),cornerMaterial);
	this.object.position.set(position)
	this.object.dad = this
	this.remove = function(){
		this.dad.remove(this)
		return this.dad
	}
	this.move = function(vector){
		this.position.add(vector);
		this.object.position.set(position)
	}
	this.snap = function(){
		this.position.copy(SnapToGrid(this.position));
		this.object.position.set(position)
	}
	this.display = function(){
		return [this.object]
	}
	this.interact = function(){
		return [this.object]
	}
}


var Border_Widget = function(size,elevation,dad){
	this.dad = dad
	this.widgetType = 1
	this.vertices = [
		new Point_Widget( new THREE.Vector3(-size,elevation,-size)),
		new Point_Widget( new THREE.Vector3(-size,elevation,size)),
		new Point_Widget( new THREE.Vector3(size,elevation,size)),
		new Point_Widget( new THREE.Vector3(size,elevation,-size))
	];
	var geometry = new THREE.Geometry()
	geometry.vertices.push(
		this.vertices[0].position,
		this.vertices[1].position,
		this.vertices[2].position,
		this.vertices[3].position
	)
	this.object = new THREE.Line(geometry)
	this.object.dad = this
	this.add = function(position){
		
		//determine part from position
		var n, temp, test_vector_A, test_vector_B, test_angle_A, test_angle_B;
		for( n=0;n<this.vertices.length-1;n++){
			test_vector_A = this.Vertices[n+1].Position.clone().sub(this.vertices[n]);
			test_vector_B = position.clone().sub(this.vertices[n]);
			test_vector_A.y = 0;
			test_vector_B.y = 0;
			test_angle_A = test_vector_A.clone().normalize();
			test_angle_B = test_vector_B.clone().normalize();
			if(test_angle_A.dot(test_angle_B)>.99&&test_vector_B.length()<test_vector_A.length()&&test_vector_B.length()>0){//perfect
				temp = SnapToGrid(position.clone());
				break;
			}
		}
		if(temp===undefined){
			return;
		}
		roster.CONTROL_MODE = 0;
		var geometry = this.border.geometry.clone();
		this.vertices.splice(n+1,0,Point_Widget(temp));
	}
	this.remove = function(chosen){
		if(chosen==this||chosen==undefined){
			this.dad.remove(this)
			return this.dad
		}
		//determine part from position
		for(var n=0;n<this.edges.length;n++){
			if(this.edges[n]===chosen){
				this.vertices.splice(n+1,1);
				break;
			}
		}
	}
	this.move = function(vector){
		for(var i=0;i<this.vertices.length;i++){
			this.vertices[i].move(vector);
		}
	}
	this.snap = function(){
		for(var i=0;i<this.vertices.length;i++){
			this.vertices[i].snap();
		}
	}
	this.update = function(){
		var geometry = new THREE.Geometry()
		for(var ii=0;ii<this.vertices.length;ii++){
			geometry.vertices.push(this.vertices[ii].position)
		}
		this.object = new THREE.Line(geometry)
		this.object.dad = this
	}
	this.display = function(){
		return [this.object]
	}
	this.interact = function(){
		var product = [this.object]
		for(var ii=0;ii<this.vertices.length;ii++){
			product.push(this.vertices[ii].object)
		}
		return product
	}
}